
def load_sites(filename):
	f = open(filename)
	prot2sites = {}
	name = ""
	sites = []

	for row in f:
		if row.startswith('#'):
			if name:
				prot2sites[name] = sites
				sites = []
			name = row.strip()
		else:
			site = [int(i) for i in row.strip().split()]
			sites.append(site)	
	if name:
		prot2sites[name] = sites

	return prot2sites


def sites2pattern(sites):
	chars = "ABCDEFGHIJKLMN"
	id = 0
	pattern = []
	for site in sites:
		for el in site:
			pattern.append((el,chars[id]))
		id += 1
	pattern.sort()
	pattern	= " ".join([str(char) for (el,char) in pattern])
	return pattern

def print_patterns(prot2sites):

	for prot,sites in prot2sites.items():
		print(prot)
		for site in sites:
			print(" ".join([str(i) for i in site]))
		print(sites2pattern(sites))
	

filename=input("Inserire nome file: ")

sites = load_sites(filename)
print_patterns(sites)