
def load_sites(filename):
	f = open(filename)
	prot2sites = {}
	name = ""
	sites = []

	for row in f:
		if row.startswith('#'):
			if name:
				prot2sites[name] = sites
				sites = []
			name = row.strip()
		else:
			site = [int(i) for i in row.strip().split()]
			sites.append(site)	
	if name:
		prot2sites[name] = sites

	return prot2sites


def sites2pattern(sites):
	id = 1
	pattern = []
	for site in sites:
		for el in site:
			pattern.append((el,id))
		id += 1
	pattern.sort()
	pattern	= " ".join([str(id) for (el,id) in pattern])
	return pattern

def pattern_stats(prot2sites):

	stats = {}

	for prot,sites in prot2sites.items():
		pattern = sites2pattern(sites)
		if pattern in stats:
			stats[pattern] += 1
		else:
			stats[pattern] = 1

	return stats

def print_frequent_patterns(stats, num):

	stats_list = [(count,pattern) for pattern,count in stats.items()]
	stats_list.sort()
	stats_list.reverse()

	print("pattern\tcount")
	for i in range(num):
		print("%s\t%d" % (stats_list[i][1], stats_list[i][0]))

filename=input("Inserire nome file: ")
num=int(input('Inserire numero di pattern: '))

sites = load_sites(filename)
stats = pattern_stats(sites)

print_frequent_patterns(stats, num)