
def load_fasta(filename):

	f = open(filename)

	name = f.readline().strip()[2:]
	seq = f.readline().strip()

	return (name,seq)

def substring_stats(seq, k):

	stats = {}

	for i in range(len(seq)-k+1):
		substr = seq[i:i+k]
		if substr in stats:
			stats[substr] += 1
		else:					
			stats[substr] = 1

	return stats

def most_common_substring(stats1, stats2):

	most_common_sub = []
	freq_sum = 0

	for (sub,freq1) in stats1.items():
		if sub not in stats2:
			continue
		freq2 = stats2[sub]
		if freq1+freq2 == freq_sum:
			most_common_sub.append((sub,freq1,freq2))
		elif freq1+freq2 > freq_sum:
			most_common_sub = [(sub,freq1,freq2)]
			freq_sum = freq1+freq2

	return most_common_sub

def print_most_common_substring(name1, name2, most_common_sub):
	print("substr\t%s\t%s" %(name1,name2))
	print("\n".join(["%s\t%d\t%d" %(sub,freq1,freq2) for (sub,freq1,freq2) in most_common_sub]))
	

filename1 = input("Nome file prima sequenza: ")
filename2 = input("Nome file seconda sequenza: ")
k = int(input("Dimensione sottosequenze: "))

(name1,seq1) = load_fasta(filename1)
(name2,seq2) = load_fasta(filename2)
stats1 = substring_stats(seq1, k)
stats2 = substring_stats(seq2, k)
most_common_sub = most_common_substring(stats1,stats2)
print_most_common_substring(name1,name2,most_common_sub)
